routes/admin.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['middleware' => ['auth', 'app.menu']], function () {    
    Route::resource('users', 'Admin\UserController');
    Route::resource('categories', 'Admin\CategoryController');
    Route::resource('units', 'Admin\UnitController');
    Route::resource('products', 'Admin\ProductController');
    Route::resource('inputs', 'Admin\InputController');
    Route::resource('outputs', 'Admin\OutputController');
    Route::resource('clients', 'Admin\ClientController');
    Route::resource('deliveries', 'Admin\DeliveryController');
    Route::resource('cashcuts', 'Admin\CashcutController');
    Route::resource('materials', 'Admin\MaterialController');
    Route::get('deliveries_credit', 'Admin\DeliveryController@deliveryCredit')->name('deliveries.credit.index');
    Route::get('deliveries_normal', 'Admin\DeliveryController@deliveryNormal')->name('deliveries.normal.index');
    //Exports
    Route::get('productsExport', 'Admin\ProductController@productsExport')->name('products.export');
    Route::post('productsImport', 'Admin\ProductController@productsImport')->name('products.import');
    //ProductsSupply
    Route::get('productsSupply', 'Admin\ProductController@productsSupply')->name('products.supply');  
    Route::get('deliveriescredit', 'Admin\DeliveryController@getDeliveriesCredit')->name('deliveries.credit');  
    Route::get('products/sold/filter', 'Admin\ProductController@soldFilter')->name('products.sold.filter');
     
});

routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('login', 'Auth\LoginController@showLoginForm')->name('login');
Route::post('login', 'Auth\LoginController@login');
Route::post('logout', 'Auth\LoginController@logout')->name('logout');
 
Route::group(['middleware' => ['auth', 'app.menu']], function () {    
    Route::get('/', 'Admin\HomeController@index')->name('home');
});

app/Models/Material.php
<?php

namespace App\Models;

class Material extends Model
{
    protected $fillable = [
        'id', 'code', 'name', 'total', 'remaining', 'bales'
    ];

    public $rules = [
        'code' => 'required|integer|min:12',
        'name' => 'required|max:150',       
        'total' => 'required|integer|min:10', 
    ];

    public function inputs()
    {
        return $this->hasMany(Input::class);
    }
}

app/Http/Controllers/Admin/MaterialController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use DataTables;
use App\Models\Role;
class MaterialController extends Controller
{
    protected $resourceName = 'materials';
    protected $resourceClass = \App\Models\Material::class;
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct() {}  

    protected function beforeSave($item = null, $request, $insert = true) {
        if (!$insert && $item->bales == 0) {
            $item->remaining = $request->total;
            $item->save();    
        } else
            $item->remaining = $request->total;
    }
}

app/Http/Controllers/Api/MaterialController.php
<?php

namespace App\Http\Controllers\Api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use DataTables;
class MaterialController extends Controller
{
    protected $resourceName = 'materials';

    protected $resourceClass = \App\Models\Material::class;
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        

    }

    public function datatables() {
        $items = $this->resourceClass::orderDesc()->get();        
        $datatable = DataTables::collection($items);
        $this->columns($datatable);
        $datatable->rawColumns(['actions']);
        return $datatable->make(true);
    }

    private function columns(&$datatable) {
        $datatable->editColumn('status', function ($item) {
                return __('general.' . ($item->status ? 'active' : 'inactive'));
            })->editColumn('created_at', function ($item) {
                return $item->created_at->format("d/m/Y H:i");
            })->editColumn('total', function ($item) {
                return number_format($item->total, 2);
            })->editColumn('remaining', function ($item) {
                return number_format($item->remaining, 2);
            })->editColumn('bales', function ($item) {
                return number_format($item->bales, 2);
            })->editColumn('actions', function ($item) {
            return view('common.actions', [
                "edit" => true,
                "routeEdit" => route("admin.$this->resourceName.edit", ['material' => $item->id]),
                "see" => true,
                "title" => __('general.see_inputs'),
                "seeEvent" => "window.seeInputs(this)",
                "items" => $item->inputs()->with('manager')->get()->map(function ($item){
                    $item->created = $item->created_at->format("d/m/Y H:i");
                    $item->quantity = $item->products()->sum('productables.quantity');
                    return $item;
                })
            ])->render();
        });
    }
}

resources/views/admin/materials/form.blade.php
<div class="row">
    @include('common.input', [
        "id" => "code",
        "required" => true,
        "clas" => "col-md-6 input-number",
        "label" => __('general.num_bill'),
        "value" => (isset($item->code) ? $item->code : old('code')),
        "type" => "number"
    ])
    @include('common.input', [
        "id" => "name",
        "required" => true,
        "clas" => "col-md-6",
        "label" => __('general.name'),
        "value" => (isset($item->name) ? $item->name : old('name'))
    ])    
</div>
<div class="row">
    @include('common.input', [
        "id" => "total",
        "required" => true,
        "clas" => "col-md-6 input-number",
        "label" => __('general.kilos'),
        "value" => (isset($item->total) ? $item->total : old('total')),
        "type" => "number"
    ])
    @include('common.select', [
        "id" => "status",
        "clas" => "col-md-6",
        "label" => __('general.datatables.status'),
        "options" => [
            "1" => __('general.active'),
            "0" => __('general.inactive'),
        ],
        "value" => (isset($item->status) ? $item->status : old('status'))
    ])
</div>

resources/views/admin/materials/index.blade.php
@extends('layouts.app')

@section('content')
    @parent
    <x-content>
        <x-slot name="title">@lang('general.administration', ['model' => __('navigation.menu.materials')])</x-slot>
        <div class="row py-4">
            <div class="col-md-12">
                <a href="{{ route('admin.materials.create') }}" class="btn btn-outline-primary float-right"><i class="fas fa-plus"></i> @lang('general.add')</a>
                <a href="{{ route('home') }}" class="btn btn-outline-dark"><i class="fas fa-long-arrow-alt-left"></i> @lang('general.cancel')</a>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                @include('common.table', [
                    "resource" => "materials",
                    "headers" => [
                        "code" => __('general.num_bill'),
                        "name" => __('general.name'),
                        "total" => __('general.kilos'),
                        "remaining" => __('general.remaining'),
                        "bales" => __('general.bales'),                                                
                        "actions" => __('general.datatables.actions'),
                    ],
                    "url" => route('api.materials.datatables')
                ])
            </div>
        </div>
        @component('components.modal', ['id' => 'materials-inputs-modal', 'title' => __('navigation.menu.inputs')])
            <div class="row">
                <div class="col-md-12">                    
                    @include('admin.controls.table', ['id' => 'materials-inputs-table', 'headers' => [
                        __('control.created_by'),
                        __('general.datatables.created_at'),
                        __('general.bales'),
                    ]])
                </div>
            </div>
            @slot('slotButton')@endslot
        @endcomponent
    </x-content>
@endsection
@push('scripts')
    <script src="{{ asset('js/build/materials.js') }}" defer></script>   
@endpush

resources/views/admin/materials/item.blade.php
@extends('layouts.app')

@section('content')
    @parent
    <x-content>
        <x-slot name="title">{{ __('general.' . (isset($item) ? 'edit' : 'add')) }} @lang('navigation.menu.materials')</x-slot>
        <div class="row py-4">
            <div class="col-md-12">
                @component('components.form', [
                    "item" => (isset($item) ? $item : null),
                    "resource" => "materials",
                    "back" => route('admin.materials.index'),
                    "updateResource" => "material"
                ])
                @include('admin.materials.form', ['item' => (isset($item) ? $item : null)])
                @endcomponent
            </div>
        </div>        
    </x-content>
@endsection